<script lang="ts" setup>
import ProgressSpinner from 'primevue/progressspinner'
import Toast from 'primevue/toast'
import { useToast } from 'primevue/usetoast'
import { onErrorCaptured } from 'vue'
import { ApiError } from '@/api/apierror'
import { useUserStore } from '@/stores/user'
import { useRouter } from 'vue-router'

const toast = useToast()

onErrorCaptured(e => {
  if (e instanceof ApiError) {
    if (e.statusCode === 401 || e.statusCode === 403) {
      // authorization problem, not logged in any more
      const store = useUserStore()
      store.logout()
      const router = useRouter()
      router.push({ path: '/' })
      return false
    }
  }
  const errorDetail = e instanceof ApiError ? `${e.statusCode} - ${e.description ?? e.message}` : e.message
  // any other error, report to user
  toast.add({ severity: 'error', summary: 'An error occurred', detail: errorDetail, life: 5000 })

  return false
})

</script>

<template>
  <div class="dark:bg-gray-900 dark:text-white/80">
    <Toast data-test="notification"/>
    <Suspense>
      <template #default>
        <router-view />
      </template>
      <template #fallback>
        <ProgressSpinner data-test="spinner" />
      </template>
    </Suspense>
  </div>
</template>

<style>
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
}

@media (prefers-color-scheme: dark) {
  body {
    background-color: #111827;
  }
}

nav {
  padding: 30px;
}

nav a {
  font-weight: bold;
  color: #2c3e50;
}

nav a.router-link-exact-active {
  color: #42b983;
}
</style>
